var express     = require('express');
var mongoose    = require('mongoose');
var bodyParser  = require('body-parser');
var extend		= require('extend');
var model       = require('./model');
var router      = express.Router();
var Product		= null;

exports.init	= function(schema) {
	var schema	= schema || model;

	try {
		Product	= mongoose.model('Product', mongoose.Schema(schema));
	} catch(err) { }

	return Product;
};

router.route('/list')
	.get(function(request, response) {
		Product
			.find({})
			.exec(function(err, res) {
				response.status(200).json(res);
			});
	});

router.route('/:id')
	.get(function(request, response) {
		Product
			.findById(request.params.id)
			.exec(function(err, res) {
				response.status(200).json(res);
			});
	});

router.route('/create')
	.post(auth, function(request, response) {
		var product	= new Product(request.body);
		product.validate(function(err) {
			if (err)
				response.sendStatus(500);
			else	{					
				product.save(function() {
					response.status(200).json(product);	
				});
			}
		});
	});

router.route('/del')
	.post(auth, function(request, response) {		
		Product			
			.findById(request.body._id)
			.exec(function(err, res) {
				res.remove(function() {
					response.sendStatus(200);
				});
			});
	});

router.route('/edit')
	.post(auth, function(request, response) {
		Product.
			findByIdAndUpdate(request.body._id, request.body)
			.exec(function(err, product) {
				response.sendStatus(200);
			});
	});

exports.model	= model;
exports.router	= router;
